找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1983|回复: 0

[分享] Changing draworder of entities

[复制链接]

已领礼包: 593个

财富等级: 财运亨通

发表于 2013-5-26 23:38:32 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
Changing draworder of entities                                                        By Balaji Ramamoorthy
An MText with background mask set can hide entities that are behind it. To send the MText to the back and make the entity behind it to be visible, we can set the DrawOrder in AutoCAD using the context menu option. This can also be achieved programmatically for an entity.
Here is a sample code to send a selected entity behind. i.e., change the draworder of the selected entity to bottom.
Using ObjectARX :
  1. static void ADSProjectSendToBottom(void)
  2. {
  3.     ads_name ent;
  4.     ads_point pt;
  5.     Acad::ErrorStatus es;
  6.     int ret = RTNORM;
  7.     ret = acedEntSel(    _T("\nSelect Entity: "),
  8.                 ent,
  9.                 pt
  10.               );
  11.     if (RTNORM != ret)
  12.         return;
  13.     AcDbObjectId ent_id;
  14.     if (Acad::eOk != acdbGetObjectId( ent_id, ent ))
  15.         return;
  16.     configureSortents();
  17.     AcDbEntity *pEnt;
  18.     es = acdbOpenObject( pEnt, ent_id, AcDb::kForRead );
  19.     if (Acad::eOk != es)
  20.         return;
  21.     AcDbSortentsTable *pSt = GetSortentsTableOf( pEnt );
  22.     pEnt->close();
  23.     if (NULL == pSt)
  24.         return;
  25.     AcDbObjectIdArray entity_array;
  26.     entity_array.append( ent_id );
  27.     pSt->moveToBottom( entity_array );
  28.     pSt->close();

  29.     // Send regen command or use the
  30.     // undocumented ads_regen method.

  31.     acDocManager->sendStringToExecute
  32.                             (
  33.                                 acDocManager->curDocument(),
  34.                                 L"_regen\n",
  35.                                 false,
  36.                                 true
  37.                             );
  38. }

Using AutoCAD .Net API :
  1. [CommandMethod("SendToBottom")]
  2. public void commandDrawOrderChange()
  3. {
  4.     Document activeDoc
  5.                 = Application.DocumentManager.MdiActiveDocument;
  6.     Database db = activeDoc.Database;
  7.     Editor ed = activeDoc.Editor;
  8.     PromptEntityOptions peo
  9.                 = new PromptEntityOptions("Select an entity : ");
  10.     PromptEntityResult per = ed.GetEntity(peo);
  11.     if (per.Status != PromptStatus.OK)
  12.     {
  13.         return;
  14.     }
  15.     ObjectId oid = per.ObjectId;
  16.     SortedList<long, ObjectId> drawOrder
  17.                             = new SortedList<long, ObjectId>();
  18.     using (Transaction tr = db.TransactionManager.StartTransaction())
  19.     {
  20.         BlockTable bt = tr.GetObject(   
  21.                                         db.BlockTableId,
  22.                                         OpenMode.ForRead
  23.                                     ) as BlockTable;
  24.         BlockTableRecord btrModelSpace =
  25.                 tr.GetObject(
  26.                                 bt[BlockTableRecord.ModelSpace],
  27.                                 OpenMode.ForRead
  28.                             ) as BlockTableRecord;
  29.         DrawOrderTable dot =
  30.                 tr.GetObject(
  31.                                 btrModelSpace.DrawOrderTableId,
  32.                                 OpenMode.ForWrite
  33.                             ) as DrawOrderTable;
  34.         ObjectIdCollection objToMove = new ObjectIdCollection();
  35.         objToMove.Add(oid);
  36.         dot.MoveToBottom(objToMove);
  37.         tr.Commit();
  38.     }
  39.     ed.WriteMessage("Done");
  40. }


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-17 22:44 , Processed in 0.174118 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表